/**********************************************************************************************
DEPRECATED CLASS
************************************************************************************************/

public with sharing class CallPlan {
    /*
    public List<Position_Account_Call_Plan__c> positionRecs  {get;set;}
    public List<User_Access_Permission__c> loggedInUserData  {get;set;}
    public List<SelectOption> allTeamInstance                {get;set;}
    public List<SelectOption> allPosition                    {get;set;}
    public Map<ID,List<ID>> teamInstancePosIdMap             {get;set;}
    public Map<ID,String> idToPosNameMap                     {get;set;}
    public string selectedTeamInstance                       {get;set;}
    public string selectedPosition                           {get;set;} 
    public string userType                                   {get;set;}
    public boolean saveLock                                  {get;set;}
    public boolean lock                                      {get;set;}
    Date repCycleCloseDate;
    Date dmCycleCloseDate;
    public boolean displayPagination                         {get;set;}
    public string soql                                       {get;set;}
    public Map<String,String> segmentToValueMap              {get;set;}
    public string columnsDataTable                           {get;set;} 
    public string columnDefsDataTable                        {get;set;}
    public Map<String,Integer> columnDefsOrderMap            {get;set;}
    public string jsonMapString                              {get;set;}
    public String allFields                                  {get;set;}
    public string errorMessage;
    public Integer listSize                                  {get;set;}
    public boolean CallPlanAccess                            {get;set;}
    public list<CR_Team_Instance_Config__c> crTeamInstList   {get;set;}
    public String hierarchyLevel                             {get;set;}
    public map<String,String> mapLevelPosition               {get;set;}
    public string selectLevel1Pos                            {get;set;}
    public string selectLevel2Pos                            {get;set;}
    public string selectLevel3Pos                            {get;set;}
    public string selectLevel4Pos                            {get;set;}
    
    public list<SelectOption> level1List                     {get;set;}
    public list<SelectOption> level2List                     {get;set;}
    public list<SelectOption> level3List                     {get;set;}
    public list<SelectOption> level4List                     {get;set;}
     
    public list<SelectOption > regionList                    {get; set;}
    public string regionSelected                             {get; set;}
    
    public list<SelectOption> districtList                   {get; set;}
    public string districtSelected                           {get; set;}
    
    public list<SelectOption> territoryList                  {get; set;}
    public string territorySelected                          {get; set;}
    
    public map<ID, list<Position__c>> mapParentIdPositionId  {get; set;}
    public List<selectOption> allTerritory                   {get;set;}
    
    public string soqlObject;
    public string selectedPositionName {get;set;}
    public string errorHCPnum {get;set;}
  
    public CallPlan(){
        CallPlanAccess       = SalesIQUtility.getCallPlanAccessPermission();
        loggedInUserData     = new List<User_Access_Permission__c>();
        allTeamInstance      = new List<SelectOption>();
        allPosition          = new List<SelectOption>();
        level1List           = new List<SelectOption>();
        level2List           = new List<SelectOption>();
        level3List           = new List<SelectOption>();
        level4List           = new List<SelectOption>();
        teamInstancePosIdMap = new Map<ID,List<ID>>();
        idToPosNameMap       = new Map<ID,String>();
        mapLevelPosition     = new Map<String,String>();
        listSize             = 0;
        loggedInUserData = SalesIQUtility.getUserAccessPermistion(Userinfo.getUserId());
        
        if(loggedInUserData!=null && loggedInUserData.size()>0)
        {   
            selectedTeamInstance = loggedInUserData[0].Team_Instance__c;
            selectedPosition     = loggedInUserData[0].Position__c;
            territorySelected    = selectedPosition;
            hierarchyLevel       = loggedInUserData[0].Position__r.Hierarchy_Level__c;
            crTeamInstList = AlignmentUtility.getTeamInstanceConfiguration(selectedTeamInstance,SalesIQGlobalConstants.HIERARCHY_CONFIG);
            //code to create a map that will have level and position type in it.This is to make dropdown on call plan page configurable. Added by Gaurav
            for(Integer i=1; i<=5 ; i++){
                mapLevelPosition.put(string.valueOf(i),'NA'); //maximum we can have four dropdowns for 5 level hierarchy
            } 
            if(crTeamInstList != null && crTeamInstList.size()>0){  
                for(CR_Team_Instance_Config__c crteamList : crTeamInstList){
                    mapLevelPosition.put(crteamList.Configuration_Name__c,crteamList.Configuration_Value__c);
                }
             
                Integer i = Integer.valueOf(hierarchyLevel);
                for(Integer a=i ; a<=mapLevelPosition.size() ; a++)
                    mapLevelPosition.put(string.valueof(a) , 'NA'); //this is to make the top level black.Example user has access to nation level but on page he can't see nation dropdown.
            }
           
            selectedPositionName = 'Home   >   Call Plan   > ' + loggedInUserData[0].Position__r.name;
            fetchLevel4Positions();
        } 
    }
    
    //These four getLevelPositions methods will fetch Position Team Instances based on selected Position and relative to Parent (incase Parent is there).Level wise dropdown list value will come.
    public void fetchLevel1Positions(){      
        level1List.clear();
        list<Position_Team_Instance__c> lsPos; 
        system.debug('****** selectLevel2Pos ' + selectLevel2Pos);      
       if(mapLevelPosition.get('1') != 'NA' || hierarchyLevel == '1'){
         if(selectLevel2Pos == null){
           lsPos = SalesIQUtility.getPositionTeamInstance(selectedPosition);
            //lsPos = SalesIQUtility.getPositionTeamInstance(selectLevel2Pos);
            }else{
           //lsPos = SalesIQUtility.getPositionTeamInstance(selectedPosition);
           lsPos = SalesIQUtility.getPositionTeamInstance(selectLevel2Pos);
            }
            if(lsPos != null && lsPos.size()>0){        
                for(Position_Team_Instance__c posInst : lsPos){          
                    level1List.add(new SelectOption(posInst.Position_ID__r.id,posInst.Position_ID__r.name));
                }
                selectLevel1Pos = lsPos[0].Position_ID__c;
            }else{
                selectLevel1Pos = null;
            }
          if(hierarchyLevel == '1')
           selectLevel1Pos = selectedPosition;
        }

        assignPositionAndTeamInstance(selectedTeamInstance, selectLevel1Pos);
        territoryTableChange();
    }
    
    public void fetchLevel2Positions(){
        level2List.clear();
        list<Position_Team_Instance__c> lsPos;
        if(mapLevelPosition.get('2') != 'NA'){ 
            if(selectLevel3Pos != null){
                lsPos = SalesIQUtility.getPositionTeamInstance(selectLevel3Pos); 
            }else{
                lsPos = SalesIQUtility.getPositionTeamInstance(selectedPosition);
            }
            if(lsPos != null && lsPos.size()>0){     
                for(Position_Team_Instance__c posInst : lsPos){          
                level2List.add(new SelectOption(posInst.Position_ID__r.id,posInst.Position_ID__r.name));
            }
            selectLevel2Pos = lsPos[0].Position_ID__c;
            }else{
                selectLevel2Pos = null;
            }
        }
        fetchLevel1Positions();
    }

    public void fetchLevel3Positions(){
        //list<SelectOption> lslevel3 = new list<SelectOption>();
        level3List.clear();
        list<Position_Team_Instance__c> lsPos;
        if(mapLevelPosition.get('3') != 'NA'){
            if(selectLevel4Pos != null){
                lsPos = SalesIQUtility.getPositionTeamInstance(selectLevel4Pos);
            }else{
                lsPos = SalesIQUtility.getPositionTeamInstance(selectedPosition);
            }
            
            if(lsPos != null && lsPos.size()>0){      
                for(Position_Team_Instance__c posInst : lsPos){          
                    level3List.add(new SelectOption(posInst.Position_ID__r.id,posInst.Position_ID__r.name));
                }
                selectLevel3Pos = lsPos[0].Position_ID__c;
            }else{
                selectLevel3Pos = null;
            }
        }
        fetchLevel2Positions();
    }
    
    public void fetchLevel4Positions(){
        //list<SelectOption> lslevel4 = new list<SelectOption>();
        level4List.clear();
        if(mapLevelPosition.get('4') != 'NA'){       
            list<Position_Team_Instance__c> lsPos = SalesIQUtility.getPositionTeamInstance(selectedPosition);
            if(lsPos != null && lsPos.size()>0){       
                for(Position_Team_Instance__c posInst : lsPos){          
                    level4List.add(new SelectOption(posInst.Position_ID__r.id,posInst.Position_ID__r.name));
                }
                selectLevel4Pos = lsPos[0].Position_ID__c;
            }else{
                selectLevel4Pos = null;
            }
        }
        fetchLevel3Positions();
    } 
          
    public void districtListChange()
    {
        boolean setTerritory = false;
        districtList = new list<SelectOption>();
        
        if(mapParentIdPositionId.containsKey(regionSelected) == true){
            for(Position__c pos : mapParentIdPositionId.get(regionSelected)){
                districtList.add(new SelectOption(pos.id,pos.name));
                if(setTerritory == false)
                {
                    districtSelected = pos.id;
                    setTerritory = true;
                }
            }
        }
        territoryListChange();
    }
    
    public void territoryListChange()
    {
        boolean setTerritory = false;
        territoryList = new list<SelectOption>();

        if(mapParentIdPositionId.containsKey(regionSelected) == true){
            for(Position__c pos : mapParentIdPositionId.get(regionSelected)){
                if(pos.id != null && pos.name != null){
                    territoryList.add(new SelectOption(pos.id,pos.name));
                    if(setTerritory == false){
                        territorySelected = pos.id;
                        setTerritory = true;
                    }
                }
            }
        }

        selectedPosition = territorySelected;
        selectedPositionName = 'Home   > Call Plan   > ' + [select id, name from position__c where id=:territorySelected].name;
        system.debug('++++++++ assignPositionAndTeamInstance called from territoryListChange ');
        assignPositionAndTeamInstance(selectedTeamInstance, selectedPosition);
    }
    
    public void territoryTableChange()
    {
        selectedPosition = selectLevel1Pos;
        if(selectedPosition != null){
            selectedPositionName = 'Home   >   Call Plan    > ' + [select id, name from position__c where id=:selectLevel1Pos].name;
            assignPositionAndTeamInstance(selectedTeamInstance, selectedPosition);
        }
        selectedPosition = selectLevel1Pos;  // Need to check with Arun and Sahil
    }
    
    
    // Method to populate all Positions under user 
    // @param TeamInstance 
 
    
    public void populatePositionList(string selectedTeamInstance)
    {
        for(ID pos : teamInstancePosIdMap.get(selectedTeamInstance)){
            allPosition.add(new SelectOption(pos, idToPosNameMap.get(pos)));    
        }
    }
    
    //Method to call another method to refresh whole CallPlan Data
    
    public void refreshData()
    {
        selectedPosition = selectLevel1Pos;
        if(selectLevel1Pos != null){
            selectedPositionName = 'Home   >   Call Plan > ' + [select id, name from position__c where id=:selectLevel1Pos].name;
            assignPositionAndTeamInstance(selectedTeamInstance,selectedPosition);
        }
    }

    
    //Method to refresh whole data 
    //@param TeamInstance - selected Team Instance
    //@param Position - selected Position
    
        
    public void assignPositionAndTeamInstance(string teamInstance, string position)
    {
        ApexPages.getMessages().clear();
        List<String> TEAM_INSTANCE_READ_FIELDS = new List<String>{'id', 'Rep_End_Date__c', 'DM_End_Date__c' };
        Team_Instance__c teamInstanceRec = null;
        if(SecurityUtil.checkRead(Team_Instance__c.SObjectType, TEAM_INSTANCE_READ_FIELDS, false))
        {
            teamInstanceRec = [select Rep_End_Date__c, DM_End_Date__c from Team_Instance__c where id =: teamInstance LIMIT 1]; 
        }
        
        
        lock = false;
        if(teamInstanceRec != null)
        {
            if(selectedPosition == selectLevel1Pos)  // Need to discuss this  with Sahil/Arun 
            {
                repCycleCloseDate = teamInstanceRec.Rep_End_Date__c;
                if(System.today()>repCycleCloseDate)    
                {
                    lock = true;
                    ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, 'Your Cycle Date has ended'));
                } 
            }
        }
        else
        {
            lock = true;
            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, 'Team Instance Record Not Found'));
        } 
        AggregateResult agg;  
        if(position != null){ //Need to check with Arun
            List<String> Position_Account_Call_Plan_Read_Fields = new List<String>{'Position__c' , 'Team_Instance__c'};   
            
            if(SecurityUtil.checkRead(Position_Account_Call_Plan__c.SObjectType, Position_Account_Call_Plan_Read_Fields, false)) 
            {
                agg = [select count(id) countRecs from Position_Account_Call_Plan__c where (Position__c =:position and Team_Instance__c =:teamInstance)];
            }
        }
        
        // If no of records are greater than 500, pagination is enabled
        if(agg != null){
            if(Integer.valueof(agg.get('countRecs'))>=500)
            {
                displayPagination = true;
            }
            else
            {
                displayPagination = false;
            }
            listSize = Integer.valueof(agg.get('countRecs'));
        }
        checkLock();
        saveLock = lock;
        initialiseDataTable();
        cimConfig();
    }
    
    //* This method Check if there is any pending Change Request
    public void checkLock()
    {       
        // Checks if there is any pending Request (Sent for approval)
        Integer totalCount = 0;
        AggregateResult hasSentSubmitRequest ;
         
        List<String> CHANGE_REQUEST_READ_FIELDS = new List<String>{'Name', 'Status__c','Destination_Position__c','Team_Instance_ID__c','Request_Type_Change__c'};
         
        if(SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELDS, false))
        {
            hasSentSubmitRequest = [select count(Status__c) tcount from Change_Request__c where Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_PENDING  and Destination_Position__c = :selectedPosition and Team_Instance_ID__c =:selectedTeamInstance and Request_Type_Change__c = :SalesIQGlobalConstants.MOVEMENT_TYPE_CALL_PLAN];
        }
        
         
        totalCount = Integer.valueof(hasSentSubmitRequest.get('tcount'));
       
        if(totalCount != 0 )
        {
            if(SecurityUtil.checkRead(Change_Request__c.SObjectType, CHANGE_REQUEST_READ_FIELDS, false)) {
                Change_Request__c changeReq = [select Name from Change_Request__c where Status__c = :SalesIQGlobalConstants.REQUEST_STATUS_PENDING  and Destination_Position__c = :selectedPosition and Team_Instance_ID__c =:selectedTeamInstance and Request_Type_Change__c = :SalesIQGlobalConstants.MOVEMENT_TYPE_CALL_PLAN LIMIT 1];
                ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, 'The Change Request '+changeReq.Name +' is pending for approval from your Manager. No other changes can be made until the Change Request is Approved or Rejected. '));
            }
            lock = true;
         }
    }

    // This method fetches list of all columns required to be displayed and forms SOQL query to be used in other methods
      
    public void initialiseDataTable()
    {
        List<Team_Instance_Object_Attribute__c> fetchAllRequiredColumns;
      
        List<String> TEAM_INSTANCE_OBJECT_ATTRIBUTE_READ_FIELDS = new List<String>{'Attribute_API_Name__c','Attribute_Display_Name__c','Data_Type__c','Display_Column_Order__c','Object_Name__c','isRequired__c','Team_Instance__c','Interface_Name__c'};
      
        if(SecurityUtil.checkRead(Team_Instance_Object_Attribute__c.SObjectType, TEAM_INSTANCE_OBJECT_ATTRIBUTE_READ_FIELDS, false))
        {
            fetchAllRequiredColumns = [Select Attribute_API_Name__c, Attribute_Display_Name__c, Data_Type__c, Display_Column_Order__c, Object_Name__c from Team_Instance_Object_Attribute__c where isRequired__c = true and Team_Instance__c =: selectedTeamInstance and Interface_Name__c =: SalesIQGlobalConstants.MOVEMENT_TYPE_CALL_PLAN];
        }
        
      
        if(fetchAllRequiredColumns != null && fetchAllRequiredColumns.size() > 0){
            Set<ID> allPicklistColumnsRecs = new Set<ID>();
            Map<String,Map<String,String>> columnAndCorrespondingInfo = new Map<String,Map<String,String>>();
            Map<String,String> indtermediateMap;
            soql = 'Select ';
            allFields ='';
          
            for(Team_Instance_Object_Attribute__c teamInstanceObj : fetchAllRequiredColumns)
            {
                indtermediateMap = new Map<String,String>();
              
                if(teamInstanceObj.Data_Type__c == 'Picklist')
                {
                    allPicklistColumnsRecs.add(teamInstanceObj.ID);
                }
              
                indtermediateMap.put('Display Name', teamInstanceObj.Attribute_Display_Name__c);
                indtermediateMap.put('Data Type', teamInstanceObj.Data_Type__c);
                indtermediateMap.put('Order', String.valueof(teamInstanceObj.Display_Column_Order__c));
                indtermediateMap.put('ID', teamInstanceObj.ID);
              
                columnAndCorrespondingInfo.put(teamInstanceObj.Attribute_API_Name__c, indtermediateMap);
              
                soql = soql + teamInstanceObj.Attribute_API_Name__c + ', ';
                allFields = allFields + teamInstanceObj.Attribute_API_Name__c + ',';
            }
          
            soql = soql.removeEnd(', ');
            allFields = allFields.removeEnd(',');
           
            soql = soql + ' from '+ fetchAllRequiredColumns[0].Object_Name__c + ' where Position__c =: selectedPosition and Team_Instance__c =: selectedTeamInstance ';
            soqlObject = fetchAllRequiredColumns[0].Object_Name__c;
          
            List<Team_Instance_Object_Attribute_Detail__c> teamInstanceDetailRecs;
          
            List<String> TEAM_INSTANCE_OBJ_ATTR_DETAIL_READ_FIELDS = new List<String>{'Object_Value_Name__c','Object_Value_Seq__c','Object_Attibute_Team_Instance__c'};
            List<String> TEAM_INSTANCE_OBJ_ATTR_READ_FIELDS      = new List<String>{'Attribute_API_Name__c'};
          
            if(SecurityUtil.checkRead(Team_Instance_Object_Attribute_Detail__c.SObjectType, TEAM_INSTANCE_OBJ_ATTR_DETAIL_READ_FIELDS, false) && 
                SecurityUtil.checkRead(Team_Instance_Object_Attribute__c.SObjectType, TEAM_INSTANCE_OBJ_ATTR_READ_FIELDS, false))
            {
                teamInstanceDetailRecs = [select Object_Value_Name__c, Object_Value_Seq__c, Object_Attibute_Team_Instance__r.Attribute_API_Name__c from Team_Instance_Object_Attribute_Detail__c where Object_Attibute_Team_Instance__c in : allPicklistColumnsRecs];
            }
            
        
            Map<String,List<Team_Instance_Object_Attribute_Detail__c>> idToValuesMap = new Map<String,List<Team_Instance_Object_Attribute_Detail__c>>();
          
            for(Team_Instance_Object_Attribute_Detail__c attributeDetailRec : teamInstanceDetailRecs)
            {
                if(idToValuesMap.containsKey(attributeDetailRec.Object_Attibute_Team_Instance__r.Attribute_API_Name__c))
                {
                    idToValuesMap.get(attributeDetailRec.Object_Attibute_Team_Instance__r.Attribute_API_Name__c).add(attributeDetailRec);
                }
                else 
                {
                    idToValuesMap.put(attributeDetailRec.Object_Attibute_Team_Instance__r.Attribute_API_Name__c, new List<Team_Instance_Object_Attribute_Detail__c>{attributeDetailRec});
                }
            }
          
            List<Team_Instance_Object_Attribute_Detail__c> tempList;
            Map<Integer,String> indexToValMap;
            String val;
            segmentToValueMap = new Map<String, String>();
          
            for(String apiName : idToValuesMap.keySet())
            {
                tempList = new List<Team_Instance_Object_Attribute_Detail__c>(idToValuesMap.get(apiName));
                indexToValMap = new Map<Integer, String>();     
                val = '';
                for(Team_Instance_Object_Attribute_Detail__c detailRec : tempList)
                {
                    indexToValMap.put(Integer.valueof(detailRec.Object_Value_Seq__c),detailRec.Object_Value_Name__c);
                }
                integer counter = 0;
              
                for(Integer seq : indexToValMap.keySet())
                {
                    counter = counter + 1;
                    val = val + (indexToValMap.get(counter)) + ',';   
                }
                val = val.removeEnd(',');
                segmentToValueMap.put(apiName, val);
            }
            jsonMapString = JSON.serialize(segmentToValueMap);
          
            List<Team_Instance_Object_Attribute__c> fetchAllVisibleColumns;
          
            TEAM_INSTANCE_OBJ_ATTR_READ_FIELDS = new List<String>{'Attribute_API_Name__c','Attribute_Display_Name__c','Data_Type__c','Display_Column_Order__c','Object_Name__c','WrapperFieldMap__c','isEnabled__c','Team_Instance__c','Interface_Name__c','Display_Column_Order__c'};
          
            if(SecurityUtil.checkRead(Team_Instance_Object_Attribute__c.SObjectType, TEAM_INSTANCE_OBJ_ATTR_READ_FIELDS, false) )
            {
                fetchAllVisibleColumns = [select Attribute_API_Name__c, Attribute_Display_Name__c, Data_Type__c, Display_Column_Order__c, Object_Name__c,WrapperFieldMap__c  from Team_Instance_Object_Attribute__c where isEnabled__c = true and Team_Instance__c =: selectedTeamInstance and Interface_Name__c =: SalesIQGlobalConstants.MOVEMENT_TYPE_CALL_PLAN order by Display_Column_Order__c];
                system.debug('#### fetchAllVisibleColumns : '+selectedTeamInstance+'---'+fetchAllVisibleColumns);
            }
            
            createColumnStructure(fetchAllVisibleColumns);
        }else{
            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, System.Label.Colums_Not_Configured));
        }
    }

    //* Method to created Columns parameter of datatable
    //* @param List<Team_Instance_Object_Attribute__c>  all Visible Columns
        
    public void createColumnStructure(List<Team_Instance_Object_Attribute__c> fetchAllVisibleColumns)
    {       
        columnsDataTable = '[';
        columnDefsOrderMap = new Map<String,Integer>();
        integer counter = 0;
        
        for(Team_Instance_Object_Attribute__c objAttr : fetchAllVisibleColumns)
        {
            columnsDataTable = columnsDataTable + '{ data: \'' + objAttr.WrapperFieldMap__c +'\' , title: \''+objAttr.Attribute_Display_Name__c+'\'},';
            columnDefsOrderMap.put(objAttr.Attribute_API_Name__c,counter);
            counter++;
        }
        columnsDataTable = columnsDataTable.removeEnd(',');
        columnsDataTable = columnsDataTable + ']'; 
        columnsDataTable = JSON.serialize(columnsDataTable);
        columnsDataTable = columnsDataTable.substring(1, columnsDataTable.length()-1);
        createColumnDefs(columnDefsOrderMap);
    }

    public integer tierCol              {get;set;}
    public integer salesDirectionCol    {get;set;}
    public integer statusCol            {get;set;}
    public integer firstNameCol         {get;set;}
    public integer lastNameCol          {get;set;}
    public integer reasonCodeCol        {get;set;}
    public integer targetCol            {get;set;}
    public integer metric3Col           {get;set;}
    public integer billingStateCol      {get;set;}

    public void createColumnDefs(Map<String,Integer> columnsExists)
    {
        if(columnsExists.containsKey('Picklist1_Updated__c')){
            tierCol = columnsExists.get('Picklist1_Updated__c');
        }else{
            tierCol = null;
        }
        if(columnsExists.containsKey('Picklist2_Updated__c')){
            salesDirectionCol = columnsExists.get('Picklist2_Updated__c');
        }else{
            salesDirectionCol = null;
        }    

        if(columnsExists.containsKey('Picklist3_Updated__c')){
            reasonCodeCol = columnsExists.get('Picklist3_Updated__c');
        }else{
            reasonCodeCol = null;
        }

        if(columnsExists.containsKey('Account__r.FirstName__c')){
            firstNameCol = columnsExists.get('Account__r.FirstName__c');
        }else{
            firstNameCol = null;
        }

        if(columnsExists.containsKey('Account__r.LastName__c')){
            lastNameCol = columnsExists.get('Account__r.LastName__c');
        }else{
            lastNameCol = null;
        }

        if(columnsExists.containsKey('Account__r.BillingState')){
            billingStateCol = columnsExists.get('Account__r.BillingState');
        }else{
            billingStateCol = null;
        }

        if(columnsExists.containsKey('isincludedCallPlan__c')){
            targetCol = columnsExists.get('isIncludedCallPlan__c');
        }else{
            targetCol = null;
        }

        if(columnsExists.containsKey('Change_Status__c')){
            statusCol = columnsExists.get('Change_Status__c');
        }else{
            statusCol = null;
        }

        if(columnsExists.containsKey('Metric3_Updated__c'))
        {
            metric3Col = columnsExists.get('Metric3_Updated__c');
        }else{
            metric3Col= null;
        }        
     }
    

    //* Remote Action Method which returns all physician list
    //* @param String soql query
    //* @param String selected Position
    //* @param String selected Team Instance
    //* @param Map<String ,String> API Name and corresponding dynamic values
    //* @param String comma seperate Fields
    //* @return List<PhyWrapper> all Physician List
     

    
    @RemoteAction
    public static List<phyWrapper> runQuery(string soql, string selectedPosition, string selectedTeamInstance, Map<String,String> segmentToValueMap, String allFieldsString)
    {
        List<Position_Account_Call_Plan__c> phyDisplayList = new List<Position_Account_Call_Plan__c>();
        List<phyWrapper> phyDisplayWrapper = new List<phyWrapper>();
        
        List<String> POSITION_ACCOUNT_CALL_PLAN_READ_FIELDS = new List<String>{'id','Team_Instance__c','Position__c'};
        List<String> ACCOUNT_READ_FIELDS = new List<String>{'id','AccountNumber'};
        
        if(SecurityUtil.checkRead(Position_Account_Call_Plan__c.SObjectType, POSITION_ACCOUNT_CALL_PLAN_READ_FIELDS, false) 
          && SecurityUtil.checkRead(Account.SObjectType, ACCOUNT_READ_FIELDS, false))
        {
            phyDisplayList = Database.query(soql); //fetches data of all physicians
        }
         
        Set<String> allFields = new Set<String>(allFieldsString.split(','));
        
        if(phyDisplayList!=null && phyDisplayList.size()>0)
        {
            for(Position_Account_Call_Plan__c pacp : phyDisplayList )
            {
                phyDisplayWrapper.add(new phyWrapper(pacp,segmentToValueMap,allFields));
            }           
        }
        phyDisplayList.clear();
        return(phyDisplayWrapper);
    }

    
    //* Remote Action Method which saves the changes made
    //* @param Map<String, Map<String,String>> ID of record changed and corresponding changes
    //* @param String selected Position
    //* @param String selected Team Instance
    @RemoteAction
    public static void savefunc(Map<String, Map<String,String>> changedMap, string posID, string teamInstance )
    {
        integer targetChange = 0;
        integer callsChange = 0;
        integer tierAchange = 0;
        integer tierBchange = 0;
        integer tierCchange = 0;
        integer tierNonTargetchange = 0;
        integer nexavarChange = 0;
        integer stivargaChange = 0;
        
        List<Position_Account_Call_Plan__c> changedAccounts = new List<Position_Account_Call_Plan__c>();
        Position_Account_Call_Plan__c tempAcc = new Position_Account_Call_Plan__c();
        
        for(ID id : changedMap.keySet())
        {
            tempAcc = new Position_Account_Call_Plan__c();
            tempAcc.ID = id;
            
            if(changedMap.get(id).get('tierChangedFlag')=='true')
            {
                if(changedMap.get(id).get('tier') != null)
                {
                    tempAcc.Picklist1_Updated__c = changedMap.get(id).get('tier');
                    
                    string newTier = tempAcc.Picklist1_Updated__c;
                    string oldTier = changedMap.get(id).get('originalTier');
                    
                    
                    if(tempAcc.Picklist1_Updated__c == 'Class 5')
                    {
                        tempAcc.Metric3_Updated__c = 0;
                        tempAcc.isIncludedCallPlan__c = false;
                        
                        callsChange = callsChange + 0;
                        tierNonTargetchange = tierNonTargetchange + 1;                       
                        targetChange = targetChange - 1;
                        
                        if(oldTier == 'Class 1')
                        {
                            tierAchange = tierAchange - 1;
                            callsChange = callsChange - 12;
                        }
                        else if(oldTier == 'Class 2')
                        {
                            tierBchange = tierBchange - 1;
                            callsChange = callsChange - 10;
                        }
                        else if(oldTier == 'Class 3')
                        {
                            tierCchange = tierCchange - 1;
                            callsChange = callsChange - 6;
                        }
                        else if(oldTier == 'Class 5')
                        {
                            targetChange = targetChange + 1;
                            tierNonTargetchange = tierNonTargetchange - 1;
                        }
                    }
                    else
                    {
                        tempAcc.isIncludedCallPlan__c = true;
                        if(tempAcc.Picklist1_Updated__c  == 'Class 1')
                        {
                            tempAcc.Metric3_Updated__c = 12; 
                            callsChange = callsChange + 12;   
                            tierAchange = tierAchange + 1;  
                                            
                            if(oldTier == 'Class 1')
                            {
                                tierAchange = tierAchange - 1;
                                callsChange = callsChange - 12;
                            }
                            else if(oldTier == 'Class 2')
                            {
                                tierBchange = tierBchange - 1;
                                callsChange = callsChange - 10;
                            }
                            else if(oldTier == 'Class 3')
                            {
                                tierCchange = tierCchange - 1;
                                callsChange = callsChange - 6;
                            }
                            else if(oldTier == 'Class 5')
                            {
                                targetChange = targetChange + 1;
                                tierNonTargetchange = tierNonTargetchange - 1;
                            }
                        }
                        else if(tempAcc.Picklist1_Updated__c == 'Class 2')
                        {    
                            tempAcc.Metric3_Updated__c = 10;  
                            callsChange = callsChange + 10;                    
                            tierBchange = tierBchange + 1;
                            if(oldTier == 'Class 1')
                            {
                                tierAchange = tierAchange - 1;
                                callsChange = callsChange - 12;
                            }
                            else if(oldTier == 'Class 2')
                            {
                                tierBchange = tierBchange - 1;
                                callsChange = callsChange - 10;
                            }
                            else if(oldTier == 'Class 3')
                            {
                                tierCchange = tierCchange - 1;
                                callsChange = callsChange - 6;
                            }
                            else if(oldTier == 'Class 5')
                            {
                                targetChange = targetChange + 1;
                                tierNonTargetchange = tierNonTargetchange - 1;
                            }
                        }
                        else if(tempAcc.Picklist1_Updated__c == 'Class 3')
                        {    
                            tempAcc.Metric3_Updated__c = 6;
                            callsChange = callsChange + 6;
                            tierCchange = tierCchange + 1;
                            
                            if(oldTier == 'Class 1')
                            {
                                tierAchange = tierAchange - 1;
                                callsChange = callsChange - 12;
                            }
                            else if(oldTier == 'Class 2')
                            {
                                tierBchange = tierBchange - 1;
                                callsChange = callsChange - 10;
                            }
                            else if(oldTier == 'Class 3')
                            {
                                tierCchange = tierCchange - 1;
                                callsChange = callsChange - 6;
                            }
                            else if(oldTier == 'Class 5')
                            {
                                targetChange = targetChange + 1;
                                tierNonTargetchange = tierNonTargetchange - 1;
                            }
                        }
                    }
                }
                    
                if(changedMap.get(id).get('reasonCode') != null)
                {
                    tempAcc.Picklist3_Updated__c = changedMap.get(id).get('reasonCode') ;
                }

                if(changedMap.get(id).get('SalesDirectionChangeFlag') =='true')
                {
                    tempAcc.Picklist2_Updated__c = changedMap.get(id).get('UpdatedSalesDirectionVal') ;
                }
                
                tempAcc.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING;
                changedAccounts.add(tempAcc);
            }
            else if(changedMap.get(id).get('SalesDirectionChangeFlag') == 'true')
            {
                tempAcc.Picklist2_Updated__c = changedMap.get(id).get('UpdatedSalesDirectionVal') ;
                tempAcc.Change_Status__c = 'Pending for Submission';
                changedAccounts.add(tempAcc);
            }
        }
        
        if(changedAccounts!=null && changedAccounts.size()>0)
        {
            update changedAccounts; 
            
            Set<ID> allCIMids = new Set<ID>();
            
            string cimQuery = 'select id from CIM_Config__c where Team_Instance__c = :teamInstance and Change_Request_Type__r.CR_Type_Name__c = \'Call_Plan_Change\' ';
            List<CIM_Config__c> cimConfigRecs;
            
            if(SecurityUtil.checkRead(CIM_Config__c.SObjectType, new list<string>{'Team_Instance__c'}, false) && SecurityUtil.checkRead(Change_Request_Type__c.SObjectType, new list<string>{'CR_Type_Name__c'}, false)) {
            	cimConfigRecs = Database.query(cimQuery);   
            }
            for(CIM_Config__c ccm : cimConfigRecs)
            {
                allCIMids.add(ccm.ID);  
            }
            
            string fetchAllPosMetric = 'select Proposed__c, CIM_Config__r.Name from CIM_Position_Metric_Summary__c where CIM_Config__c in :allCIMids and Position_Team_Instance__r.Position_ID__c = :posID';
            
            List<CIM_Position_Metric_Summary__c> cimPosMetricRecs;
            cimPosMetricRecs = Database.query(fetchAllPosMetric);
            if(cimPosMetricRecs!=null && cimPosMetricRecs.size() > 0)
            {
                for(CIM_Position_Metric_Summary__c cpms : cimPosMetricRecs)
                {
                    if(cpms.CIM_Config__r.Name == 'No of Targets')
                    {
                        cpms.Proposed__c = String.valueof(Integer.valueof(cpms.Proposed__c) + targetChange);
                    }
                    else if(cpms.CIM_Config__r.Name == 'Total Calls')
                    {
                        cpms.Proposed__c = String.valueof(Integer.valueof(cpms.Proposed__c) + callsChange);
                    }
                    else if(cpms.CIM_Config__r.Name == 'No of Tier1 Physician')
                    {
                        cpms.Proposed__c = String.valueof(Integer.valueof(cpms.Proposed__c) + tierAchange);
                    }
                    else if(cpms.CIM_Config__r.Name == 'No of Tier2 Physician')
                    {
                        cpms.Proposed__c = String.valueof(Integer.valueof(cpms.Proposed__c) + tierBchange);
                    }
                    else if(cpms.CIM_Config__r.Name == 'No of Tier3 Physician')
                    {
                        cpms.Proposed__c = String.valueof(Integer.valueof(cpms.Proposed__c) + tierCchange);
                    }
                }
                update cimPosMetricRecs;
            }
        }
    }     
    
    //* This method is shows Reason Code Error 
    public void showReasonCodeError()
    {
        errorMessage = errorHCPnum + ':- Reason code is mandatory when Physician is changed from Target to Non Target or vice versa. Please select an appropriate reason code.';
        ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error, errorMessage));
    }
    
    public void showSalesDirectionError()
    {
        errorMessage = errorHCPnum + ':- Sales direction is mandatory for \'Class 1\', \'Class 2\' or \'Class 3\'';
        ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error, errorMessage));
    }
    
    //* This method is shows Invalid Sales Direction Error 
    public void showSalesDirectionErrorClass5()
    {
        errorMessage = errorHCPnum + ':- Please ensure that updated sales direction is \'None\' in case of \'Class 5\'';
        ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error, errorMessage));        
    }
    
//    * This method updates flag in position table which is used for mass emailing  
    public void callSaveError()
    {
    	Position_Team_Instance__c posFlag;
    	if(SecurityUtil.checkRead(Position_Team_Instance__c.SObjectType, new list<string>{'isCallPlanSubmitted__c', 'Position_ID__c', 'Team_Instance_ID__c'}, false)) {
        	posFlag = [select isCallPlanSubmitted__c from Position_Team_Instance__c where Position_ID__c =:selectedPosition and Team_Instance_ID__c =:selectedTeamInstance];
        	posFlag.isCallPlanSubmitted__c = false;
    	}
    	
    	if(SecurityUtil.checkUpdate(Position_Team_Instance__c.SObjectType, new list<string>{'isCallPlanSubmitted__c'}, false)) {
        	update posFlag;        
    	}
        refreshData();
    }
    
//    * This method is called when a user clicks on Submit Button  
    public void submit()
    {
        refreshData();
        if(lock)
        { 
            errorMessage = 'Bussiness Rules Voilated, Changes have been saved but cannot be submitted';
            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, errorMessage));
            return;
        }
        
        Change_Request__c changedRec;
        string MovedAcc     =   '';               // Intitialze all move Accounts
        changedRec          =   new Change_Request__c();           // Creates new Change Request                                               
        changedRec.Reason__c =  'Call Plan Changes';
        
        string namespace = SalesIQGlobalConstants.NAME_SPACE + 'Change_Request__c';
        changedRec.recordtypeId = SalesIQUtility.getselctedRecordType(namespace,'Call_Plan_Change' );
        changedRec.Request_Type_Change__c = SalesIQGlobalConstants.MOVEMENT_TYPE_CALL_PLAN;               
      
        Position__c dmPos;
        if(selectedPosition !=null){
            List<String> POSITION_READ_FIELDS = new List<String>{'ID','Name','Parent_Position__c'};
      
            if(SecurityUtil.checkRead(Position__c.SObjectType, POSITION_READ_FIELDS, false))
            {
                dmPos = [select Parent_Position__c from Position__c where ID = :selectedPosition order by Name limit 1];
            }
        }
      
        List<User_Access_Permission__c> approverDetails;
      
        if(dmPos != null)
            if(SecurityUtil.checkRead(User_Access_Permission__c.SObjectType, new List<String>{'User__c', 'Position__c', 'Team_Instance__c'}, false))
            {
                approverDetails = [select User__c from User_Access_Permission__c where Position__c = :dmPos.Parent_Position__c and Team_Instance__c = :selectedTeamInstance and is_Active__c = true];
            }
      
        // What if there are multiple users ?
        
        if(approverDetails!=null && approverDetails.size()>0)
        {
            for(User_Access_Permission__c ua:approverDetails)
            {
                if(ua.User__c !=null)    
                {
                    changedRec.Approver1__c = ua.User__c;
                    changedRec.Approver2__c = ua.User__c;
                    changedRec.Approver3__c = ua.User__c;
                    changedRec.Approver4__c = ua.User__c;  
                    if(ua.User__c == UserInfo.getUserID())
                    {
                        changedRec.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
                        changedRec.Is_Auto_Approved__c = true;
                    }
                    else
                    {
                        changedRec.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;
                        changedRec.Is_Auto_Approved__c = false;
                    }
                }
                else
                {
                    changedRec.Approver1__c = null;
                    changedRec.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
                }
            }
        }
        
        string newSoql = soql;
        soql = soql + ' and Change_Status__c = \'Pending for Submission\'';
        
        List<Position_Account_Call_Plan__c> submittedAccounts ;
        
        list<string> soqlFields;
        if(allFields!=null && allFields!=''){
            soqlFields = allFields.split(',');
        }
        
        list<string> SOQL_READ_FIELDS = new list<string>();
        SOQL_READ_FIELDS.addAll(soqlFields);
        
        submittedAccounts = Database.query(soql);
    
        if(submittedAccounts!=null && submittedAccounts.size()>0)
        {       
            string AccountMoved = '';
            integer changeFlag = 0;
            // Loop adds all the changed accounts to the string
            for(Position_Account_Call_Plan__c pacp : submittedAccounts)
            {
                changeFlag = 0;
                if(allFields.contains('Picklist1_Segment__c') && allFields.contains('Picklist2_Segment__c'))
                {
                    if(pacp.Picklist1_Updated__c != pacp.Picklist1_Segment_Approved__c || pacp.Picklist2_Updated__c !=pacp.Picklist2_Segment_Approved__c)
                    {
                        MovedAcc += pacp.Account__r.AccountNumber +',';
                        pacp.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_SUBMITTED;                        
                    }
                    else
                    {
                        pacp.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_NO_CHANGE;
                    }                   
                }
            }
            try{
                if(SecurityUtil.checkUpdate(Position_Account_Call_Plan__c.SObjectType,new list<string>{'Change_Status__c'},false)){
                    update submittedAccounts;
                }
            }
            catch(DmlException e){
                //system.debug('exception id ' + e.getMessage());
            }
            
            if(MovedAcc.length()>0)
            {
                changedRec.Account_Moved_Id__c = MovedAcc.removeEnd(',') ;
                changedRec.is_Active__c = True;
                changedRec.Destination_Position__c = selectedPosition;  
                changedRec.Team_Instance_ID__c = selectedTeamInstance;
                
                List<String> CHANGE_REQUEST_INSERT = new List<String>{'Approver1__c','Approver2__c','Approver3__c','Approver4__c','Status__c','Account_Moved_Id__c','is_Active__c','Destination_Position__c','Team_Instance_ID__c'};
                if(SecurityUtil.checkInsert(Change_Request__c.SObjectType, CHANGE_REQUEST_INSERT, false))
                {
                    insert changedRec;
                }
                
            }
            //Generating Change Request

            // Pending status....
            
            if(changedRec.Status__c == SalesIQGlobalConstants.REQUEST_STATUS_PENDING && MovedAcc.length()>0)
            {
                List<String> POS_TEAM_INSTANCE_READ_FIELD = new List<String>{'isCallPlanSubmitted__c'};
                List<String> POS_TEAM_INSTANCE_UPDATE_FIELD = new List<String>{'isCallPlanSubmitted__c'};
         
                if(SecurityUtil.checkRead(Position_Team_Instance__c.SObjectType, POS_TEAM_INSTANCE_READ_FIELD, false))
                {
                    Position_Team_Instance__c posFlag = [select isCallPlanSubmitted__c from Position_Team_Instance__c where Position_ID__c =:selectedPosition and Team_Instance_ID__c =:selectedTeamInstance];
                  
                    if(SecurityUtil.checkUpdate(Position_Team_Instance__c.SObjectType, POS_TEAM_INSTANCE_UPDATE_FIELD, false))
                    {
                        posFlag.isCallPlanSubmitted__c = true;
                        update posFlag;
                    }
                }
                submitCrForApproval(changedRec);
            }
        }
        refreshData();
    }
    
    //* This method resets physicians data to last approved values
    //* @param string position ID 
    //* @return List<phyWrapper> updated physician List
    
    @RemoteAction 
    public static Integer undo(string userPosition, string teamInstance)
    {
        string soql = 'select Picklist1_Updated__c, Picklist1_Segment_Approved__c, Picklist1_Segment__c,  Picklist2_Updated__c, Picklist2_Segment_Approved__c,Picklist2_Segment__c, Picklist3_Updated__c, Picklist3_Segment_Approved__c,Picklist3_Segment__c, Metric3_Updated__c, Metric3_Approved__c, isIncludedCallPLan__c from Position_Account_Call_Plan__c where Position__c =:userPosition and Team_Instance__c = :teamInstance';
        List<Position_Account_Call_Plan__c> phyDisplayList;
        List<String> POS_ACC_CALL_PLAN_WRITE_FIELDS = new List<String>{'Picklist1_Updated__c','Picklist1_Segment_Approved__c','Picklist1_Segment__c','Picklist2_Updated__c','Picklist2_Segment_Approved__c','Picklist2_Segment__c','Picklist3_Updated__c','Picklist3_Segment_Approved__c','Picklist3_Segment__c','Metric3_Updated__c','Metric3_Approved__c','isIncludedCallPLan__c','Position__c','Team_Instance__c'};
        if(SecurityUtil.checkRead(Position_Account_Call_Plan__c.SObjectType, POS_ACC_CALL_PLAN_WRITE_FIELDS, false))
        {
            phyDisplayList = Database.query(soql); //fetches data of all physicians
        }
        
        List<phyWrapper> phyDisplayWrapper = new List<phyWrapper>();
        
        for(Position_Account_Call_Plan__c pacp : phyDisplayList)
        {  
            pacp.Metric3_Updated__c = pacp.Metric3_Approved__c;
            pacp.Picklist1_Updated__c = String.valueof(pacp.Picklist1_Segment_Approved__c);
            pacp.Picklist3_Updated__c = pacp.Picklist3_Segment_Approved__c;
            pacp.Picklist2_Updated__c =pacp.Picklist2_Segment_Approved__c;
            
            if(pacp.Picklist1_Updated__c == 'Class 1' || pacp.Picklist1_Updated__c == 'Class 2' || pacp.Picklist1_Updated__c == 'Class 3' )
            {
                pacp.isIncludedCallPlan__c = true;
            } 
            else if(pacp.Picklist1_Updated__c == 'Non Target')
            { 
                pacp.isIncludedCallPlan__c = false;
            }
            
            if(pacp.Picklist1_Segment_Approved__c != pacp.Picklist1_Segment__c)
            {
                system.debug('+++++++++++++++ Picklist1 not same '+pacp.Picklist1_Segment_Approved__c +'   '+pacp.Picklist1_Segment__c);
            }
            
            if(pacp.Picklist2_Segment_Approved__c != pacp.Picklist2_Segment__c)
            {
                system.debug('+++++++++++++++ Picklist2 not same '+pacp.Picklist2_Segment_Approved__c +'   '+pacp.Picklist2_Segment__c);
            }
            
            if(pacp.Picklist1_Segment_Approved__c != pacp.Picklist1_Segment__c || pacp.Picklist2_Segment_Approved__c != pacp.Picklist2_Segment__c)
            {
                pacp.Change_Status__c= SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;               
            }
            else
            {
                pacp.Change_Status__c= SalesIQGlobalConstants.REQUEST_STATUS_NO_CHANGE;
            }
        }
           
        Set<ID> allCIMids = new Set<ID>();
        List<CIM_Config__c> cimConfigRecs = new list <CIM_Config__c>();
        string cimQuery = 'select id from CIM_Config__c where Team_Instance__c = :teamInstance and Change_Request_Type__r.CR_Type_Name__c = \'Call_Plan_Change\'';
        
        if(SecurityUtil.checkRead(CIM_Config__c.SObjectType, new list<string>{'Team_Instance__c', 'Change_Request_Type__c'}, false) && SecurityUtil.checkRead(Change_Request_Type__c.SObjectType, new list<string>{'CR_Type_Name__c'}, false)){
        	cimConfigRecs = Database.query(cimQuery);
    	}
    	
        for(CIM_Config__c ccm : cimConfigRecs)
        {
            allCIMids.add(ccm.ID);  
        }
        
        list<CIM_Position_Metric_Summary__c> cimPosMetricRecs = new list <CIM_Position_Metric_Summary__c>();        
        string fetchAllPosMetric = 'select Proposed__c, Approved__c from CIM_Position_Metric_Summary__c where CIM_Config__c in :allCIMids and Position_Team_Instance__r.Position_ID__c = :userPosition ';
        
        if(SecurityUtil.checkRead(CIM_Position_Metric_Summary__c.SObjectType, new list<string>{'Proposed__c', 'Approved__c', 'CIM_Config__c', 'Position_Team_Instance__c'}, false) && SecurityUtil.checkRead(Position_Team_Instance__c.SObjectType, new list<string>{'Position_ID__c'}, false)){
        	cimPosMetricRecs = Database.query(fetchAllPosMetric);
        }
        
        for(CIM_Position_Metric_Summary__c cpms : cimPosMetricRecs)
        {
            cpms.Proposed__c = cpms.Approved__c;
        }     
        
        if(SecurityUtil.checkUpdate(CIM_Position_Metric_Summary__c.SObjectType, new list<string>{'Proposed__c'}, false)){
        	update cimPosMetricRecs;     
        }	
        
        
        if(SecurityUtil.checkUpdate(Position_Account_Call_Plan__c.SObjectType, POS_ACC_CALL_PLAN_WRITE_FIELDS, false)){
        	update phyDisplayList;
        }
          
        phyDisplayList.clear();
        ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, 'The Call Plan has been restored to previous approved state.'));
        
        return 1;
    }
    
    integer originalVal;
    integer updatedVal;
    integer optimumValue;
    string displayName;
    boolean enforcable;
    integer metricStatus;
    integer warningMin;
    integer warningMax;
    integer errorMin;
    integer errorMax;
    integer warningMinPer;
    integer warningMaxPer;
    integer errorMinPer;
    integer errorMaxPer;
    string metricErrorMessage;
    string metricTooltipMessage;

    public List<String> headersList {get;set;}
    public List<Integer> originalValuesList {get;set;}
    public List<Integer> updatedValuesList {get;set;}
    public Map<String,Integer> metricStatusMap {get;set;}
    public  Map<String,Boolean> enforcableValuesMap {get;set;}
    public Map<String,String> toolTipMessageMap {get;set;}

    //* This method implements CIM Config i.e. populating metrics dynamically
    public void cimConfig()
    {
        string cimQuery = 'select id,Name,(select Original__c,Approved__c,Proposed__c,Optimum__c from CIM_Position_Metric_Summary__r where Position_Team_Instance__r.Position_ID__c =:selectedPosition LIMIT 1),Display_Name__c,Enforcable__c,Error_Message__c,isOptimum__c ,Threshold_Max__c, Threshold_Min__c, Threshold_Warning_Max__c, Threshold_Warning_Min__c, Tooltip_Message__c, Visible__c from CIM_Config__c where Team_Instance__c = :selectedTeamInstance and Enable__c= true and Change_Request_Type__r.CR_Type_Name__c = \'Call_Plan_Change\'';
        List<CIM_Config__c> cimConfigRecs = new list<CIM_Config__c>();
        
        List<String> CIM_CONFIG_READ = new List<String>{'id','Name','Display_Name__c','Enforcable__c','Error_Message__c','isOptimum__c' ,'Threshold_Max__c', 'Threshold_Min__c', 'Threshold_Warning_Max__c', 'Threshold_Warning_Min__c', 'Tooltip_Message__c', 'Visible__c','Team_Instance__c','Enable__c','Change_Request_Type__c'};
        List<String> CHANGE_REQUEST_TYPE_READ = new List<String>{'CR_Type_Name__c'};
        List<String> CIM_POS_METRIC_SUMMARY_READ = new List<String>{'Original__c','Approved__c','Proposed__c','Optimum__c', 'Position_Team_Instance__c'};
        List<String> POS_TEAM_INSTANCE_READ = new List<String>{'Position_ID__c'};
    
        if(SecurityUtil.checkRead(CIM_Config__c.SObjectType, CIM_CONFIG_READ, false) 
            && SecurityUtil.checkRead(Change_Request_Type__c.SObjectType, CHANGE_REQUEST_TYPE_READ, false) 
            && SecurityUtil.checkRead(CIM_Position_Metric_Summary__c.SObjectType, CIM_POS_METRIC_SUMMARY_READ, false)
            && SecurityUtil.checkRead(Position_Team_Instance__c.SObjectType, POS_TEAM_INSTANCE_READ, false))
        {
            cimConfigRecs = Database.query(cimQuery);
        }
        
     
        headersList = new List<String>();
        originalValuesList = new List<Integer>();
        updatedValuesList = new List<Integer>();
        enforcableValuesMap = new Map<String,Boolean>();
        toolTipMessageMap = new Map<String,String>();
        metricStatusMap = new Map<String,Integer>();
        
        for(CIM_Config__c cimRec : cimConfigRecs)
        {
            if(cimRec.CIM_Position_Metric_Summary__r != null && cimRec.CIM_Position_Metric_Summary__r.size() > 0){
                originalVal = Integer.valueof(cimRec.CIM_Position_Metric_Summary__r[0].Original__c);
                updatedVal  = Integer.valueof(cimRec.CIM_Position_Metric_Summary__r[0].Proposed__c);
                displayName = cimRec.Display_Name__c;
                enforcable  = cimRec.Enforcable__c;
              
                if(cimRec.Error_Message__c == null)
                {
                    metricErrorMessage = ' ';
                }
                else
                {
                    metricErrorMessage = cimRec.Error_Message__c;   
                }
              
                if(cimRec.Tooltip_Message__c == null)
                {
                    metricTooltipMessage = ' ';         
                }
                else
                {
                    metricTooltipMessage = cimRec.Tooltip_Message__c;
                }
              
                if(cimRec.isOptimum__c == true)
                {
                    optimumValue = Integer.valueof(cimRec.CIM_Position_Metric_Summary__r[0].Optimum__c);            
                }
                else
                {
                    optimumValue = originalVal;                         
                }
              
                if(cimRec.Threshold_Warning_Min__c != null)
                {
                    warningMinPer = Integer.valueof(cimRec.Threshold_Warning_Min__c);
                    warningMaxPer = Integer.valueof(cimRec.Threshold_Warning_Max__c);
                    errorMinPer = Integer.valueof(cimRec.Threshold_Min__c);
                    errorMaxPer = Integer.valueof(cimRec.Threshold_Max__c);
                  
                    warningMin = optimumValue + ((warningMinPer) * optimumValue)/100;
                    warningMax = optimumValue + ((warningMaxPer) * optimumValue)/100;
                    errorMin   = optimumValue + ((errorMinPer) * optimumValue)/100;
                    errorMax   = optimumValue + ((errorMaxPer) * optimumValue)/100;
                }
                              
                if(enforcable)
                {
                    if(updatedVal < errorMin || updatedVal > errorMax)
                    {
                        metricStatus = 0;
                        if(enforcable)
                        {
                            lock = true;        
                            ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.INFO, metricErrorMessage));
                        }
                    }
                    else if(updatedVal < warningMin || updatedVal > warningMax)
                    {
                        metricStatus = 1;
                    }
                    else
                    {
                        metricStatus = 2;
                    }
                }
                else
                {
                    metricStatus = 2;
                }
              
                headersList.add(displayName);
                originalValuesList.add(originalVal);
                updatedValuesList.add(updatedVal);
                metricStatusMap.put(displayName,metricStatus);
                enforcableValuesMap.put(displayName,enforcable);
                toolTipMessageMap.put(displayName,metricTooltipMessage);
            }
        }
        horizontalBar();
    }
   
    public string displayNameHbar {get;set;}
    public string sliderVal {get;set;}
   
    //* This method dynamically determins the value to be shown on Indicator  
    
    public void horizontalBar()
    {
        string cimHbarQuery = 'select id,Name,(select Original__c,Approved__c,Proposed__c,Optimum__c from CIM_Position_Metric_Summary__r where Position_Team_Instance__r.Position_ID__c =:selectedPosition LIMIT 1),isOptimum__c, Display_Name__c, Visible__c from CIM_Config__c where Team_Instance__c = :selectedTeamInstance and Enable__c= true and Visible__c = true and Change_Request_Type__r.CR_Type_Name__c = \'Call_Plan_Change\' LIMIT 1';
        list<CIM_Config__c> cimConfigList = new list<CIM_Config__c>(); 
        CIM_Config__c cimConfigHbarRecs ;
        
        List<String> CIM_CONFIG_READ = new List<String>{'id','Name','Display_Name__c','Enforcable__c','Error_Message__c','isOptimum__c' ,'Threshold_Max__c', 'Threshold_Min__c', 'Threshold_Warning_Max__c', 'Threshold_Warning_Min__c', 'Tooltip_Message__c', 'Visible__c','Team_Instance__c','Enable__c','Change_Request_Type__c'};
        List<String> CHANGE_REQUEST_TYPE_READ = new List<String>{'CR_Type_Name__c'};
        List<String> CIM_POS_METRIC_SUMMARY_READ = new List<String>{'Original__c','Approved__c','Proposed__c','Optimum__c', 'Position_Team_Instance__c'};
        List<String> POS_TEAM_INSTANCE_READ = new List<String>{'Position_ID__c'};
    
        if(SecurityUtil.checkRead(CIM_Config__c.SObjectType, CIM_CONFIG_READ, false) 
            && SecurityUtil.checkRead(Change_Request_Type__c.SObjectType, CHANGE_REQUEST_TYPE_READ, false) 
            && SecurityUtil.checkRead(CIM_Position_Metric_Summary__c.SObjectType, CIM_POS_METRIC_SUMMARY_READ, false) 
            && SecurityUtil.checkRead(Position_Team_Instance__c.SObjectType, POS_TEAM_INSTANCE_READ, false))
        {
            cimConfigList = Database.query(cimHbarQuery);
        }
        
    
        if(cimConfigList != null && cimConfigList.size() > 0)
        {
            cimConfigHbarRecs = cimConfigList[0];
            Integer originalVal;
            if(cimConfigHbarRecs.CIM_Position_Metric_Summary__r != null && cimConfigHbarRecs.CIM_Position_Metric_Summary__r.size() > 0){
                if(cimConfigHbarRecs.isOptimum__c == true)
                {
                    originalVal = Integer.valueof(cimConfigHbarRecs.CIM_Position_Metric_Summary__r[0].Optimum__c);
                }
                else
                {
                    originalVal = Integer.valueof(cimConfigHbarRecs.CIM_Position_Metric_Summary__r[0].Original__c);
                }
               
                Integer updatedVal =  Integer.valueof(cimConfigHbarRecs.CIM_Position_Metric_Summary__r[0].Proposed__c);
              
                displayNameHbar = cimConfigHbarRecs.Display_Name__c;
              
                if(originalVal != 0)
                {
                    sliderVal = String.valueof(((updatedVal*100)/originalVal));
                }
                else
                {
                    sliderVal = '';
                }
            }
        }
    } 
   
    public class phyWrapper
    {
        public string id                                {get;set;}
        public string accountID                         {get;set;}
        public string firstName                         {get;set;}
        public string lastName                          {get;set;}
        public string name                              {get;set;}
        public string status                            {get;set;}
        public string speciality                        {get;set;}
        public string accNum                            {get;set;}
        public string picklist2_Segment                 {get;set;}
        public string picklist1_Segment                 {get;set;}
        public string picklist2_Updated                 {get;set;}
        public string picklist1_Updated                 {get;set;}
        public string picklist3_Updated                 {get;set;}
        public Integer metric3_Updated                  {get;set;}
        public string picklist2_Approved                {get;set;}
        public Integer metric3_Approved                 {get;set;}
        public string picklist1_Approved                {get;set;}
        public Integer metric3                          {get;set;}  
        public Map<String,String> picklist1_UpdatedMap  {get;set;}
        public Map<String,String> picklist2_UpdatedMap  {get;set;}
        public Map<String,String> picklist3_UpdatedMap  {get;set;}
        public boolean isTarget                         {get;set;}
        public string city                              {get;set;}
        public string state                             {get;set;}
        public string zip                               {get;set;}
        public string address              {get;set;}              
        public string segment6                          {get;set;}
        public string segment7                          {get;set;}
        public string segment8                          {get;set;}
        public string segment9                          {get;set;}
        public string segment10                         {get;set;}
        public Decimal metric6                          {get;set;}
        public Decimal metric7                          {get;set;}
        public Decimal metric8                          {get;set;}
        public Decimal metric9                          {get;set;}
        public Decimal metric10                         {get;set;}
        public string source                            {get;set;}
        public string speciality1                       {get;set;}
        public string tempUpdatedSalesDirection         {get;set;}
        
        public phyWrapper(Position_Account_Call_Plan__c pacp , Map<String,String> segmentToValueMap , Set<String> allFields)
        { 
            picklist1_UpdatedMap = new Map<String,String>();
            picklist2_UpdatedMap = new Map<String,String>();
            picklist3_UpdatedMap = new Map<String,String>();
            
            id                          =       pacp.ID;
            
            if(allFields.contains('Account__r.'+'FirstName__c')){
                if(pacp.Account__r.FirstName__c == null){
                    firstName                   =       'Not Available';    
                }else{
                    firstName                   =       pacp.Account__r.FirstName__c;
                }
            }
            
            if(allFields.contains('Account__r.'+'LastName__c'))
            {           
                if(pacp.Account__r.LastName__c == null)
                {
                    lastName                    =       'Not Available';    
                }
                else
                {
                    lastName                    =       pacp.Account__r.LastName__c;
                }
            }           
            
            if(allFields.contains('Account__c'))
            {
                accountID                   =       pacp.Account__c;
            }
            
            if(allFields.contains('Account__r.Name'))
            {
                name                        =       pacp.Account__r.Name;
            }
            
            if(allFields.contains('Change_Status__c'))
            { 
                status = (pacp.Change_Status__c != null) ? pacp.Change_Status__c : ' ';
            }
            else
            {
                status='No Change';
            }
            
            if(allFields.contains('Account__r.'+'Speciality__c'))
            {
                if(pacp.Account__r.Speciality__c != null && pacp.Account__r.Speciality__c != '')
                {
                    speciality                  =       pacp.Account__r.Speciality__c;
                }
                else
                {
                    speciality = ' ';
                }
            } 
            
            if(allFields.contains('Account__r.'+'Speciality1__c'))
            {
                if(pacp.Account__r.Speciality1__c != null && pacp.Account__r.Speciality1__c != '')
                {
                    speciality1                 =       pacp.Account__r.Speciality1__c;    
                }
                else
                {
                    speciality1 = ' ';
                }
            }   
            if(allFields.contains('Account__r.External_Account_Number__c'))
            {
                accNum = (pacp.Account__r.AccountNumber != null) ? pacp.Account__r.AccountNumber : ' ';
            }
            
            if(allFields.contains('Picklist2_Segment__c'))
            {
                picklist2_Segment           =       pacp.Picklist2_Segment__c;
                picklist2_Updated           =       pacp.Picklist2_Updated__c;
                picklist2_Approved          =       pacp.Picklist2_Segment_Approved__c; 
                tempUpdatedSalesDirection   =       picklist2_Updated;
                if(segmentToValueMap.containsKey('Picklist2_Updated__c'))
                {
                    List<String> allVals = (segmentToValueMap.get('Picklist2_Updated__c')).split(',');
                    for(String str : allVals)
                    {
                        picklist2_UpdatedMap.put(str,str);
                    }
                }
            }
            
            if(allFields.contains('Picklist1_Segment__c'))
            {
                picklist1_Segment           =       pacp.Picklist1_Segment__c;
                picklist1_Updated           =       pacp.Picklist1_Updated__c;
                picklist1_Approved          =       pacp.Picklist1_Segment_Approved__c; 
                
                if(segmentToValueMap.containsKey('Picklist1_Updated__c'))
                {
                    List<String> allVals = (segmentToValueMap.get('Picklist1_Updated__c')).split(',');
                    
                    system.debug('+++++++++ Hey all Vals picklist1 is '+allVals);
                    for(String str : allVals)
                    {
                        picklist1_UpdatedMap.put(str,str);
                    }
                }
            }
                        
            if(allFields.contains('Picklist3_Updated__c'))
            {                       
                picklist3_Updated           =       pacp.Picklist3_Updated__c; 
                if(segmentToValueMap.containsKey('Picklist3_Updated__c'))
                {
                    List<String> allVals = (segmentToValueMap.get('Picklist3_Updated__c')).split(',');
                    for(String str : allVals)
                    {
                        picklist3_UpdatedMap.put(str,str);
                    }
                }
            }
            
            if(allFields.contains('Metric3__c'))
            {
                metric3                     =       Integer.valueof(pacp.Metric3__c);
                metric3_Updated             =       Integer.valueof(pacp.Metric3_Updated__c);
                metric3_Approved            =       Integer.valueof(pacp.Metric3_Approved__c);  
            }           
            
            if(allFields.contains('isIncludedCallPlan__c'))
            {
                isTarget                    =       pacp.isIncludedCallPlan__c;
            }
            
            if(allFields.contains('Account__r.BillingCity'))
            {
                city                        =       pacp.Account__r.BillingCity;
            }
            
            if(allFields.contains('Account__r.BillingState'))
            {
                state                       =       pacp.Account__r.BillingState;
            }
            
            if(allFields.contains('Account__r.BillingPostalCode'))
            {
                zip                         =       pacp.Account__r.BillingPostalCode;
            }
            
            if(allFields.contains('Account__r.BillingStreet'))
            {
                address                         =       pacp.Account__r.BillingStreet;
            }           
            
            if(allFields.contains('Segment6__c'))
            {
              segment6 = (pacp.Segment6__c != null) ? pacp.Segment6__c : '';
            }
            
            if(allFields.contains('Segment7__c'))
            {
                segment7 = (pacp.Segment7__c != null) ? pacp.Segment6__c : '';
            }

            if(allFields.contains('Segment8__c'))
            {
                segment8 = pacp.Segment8__c;
            }
 
            if(allFields.contains('Segment9__c'))
            {
                segment9 = pacp.Segment9__c;
            }

            if(allFields.contains('Segment10__c'))
            {
                segment10 = pacp.Segment10__c;
            }

            if(allFields.contains('Metric6__c'))
            {
                metric6 = pacp.Metric6__c;
            }

            if(allFields.contains('Metric7__c'))
            {
                metric7 = pacp.Metric7__c;
            }

            if(allFields.contains('Metric8__c'))
            {
                metric8 = pacp.Metric8__c;
            }

            if(allFields.contains('Metric9__c'))
            {
                metric9 = pacp.Metric9__c;
            }

            if(allFields.contains('Metric10__c'))
            {
                metric10 = pacp.Metric10__c;
            }
            
            if(allFields.contains('Source__c'))
            {
                source = pacp.Source__c;
            }
        }
    } 
    
    public void submitCrForApproval(Change_Request__c changeRequest)
    {
        // Create an approval request for the Change Request
        Approval.ProcessSubmitRequest req = new Approval.ProcessSubmitRequest();
        req.setObjectId(changeRequest.id);
        // Submit the approval request for the Change Request
        Approval.ProcessResult result = Approval.process(req);
    }
    public void doNothing(){
        system.debug('DO nothing');
    }

    */
}